package com.fidufosyga.rules;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.StringTokenizer;

import com.fidufosyga.rules.util.ObtenerDiasEntreFechas;
import com.fidufosyga.rules.util.ValidarFecha;

public class ValorCampoFechaNacimientoFechaNovedad extends AbstractRule {

	String DATE_FORMAT = "dd/MM/yyyy";

	SimpleDateFormat sdf;

	public void setParams(Object[] params) {
		String valores = (String) params[2];
		ArrayList<String> listaString = new ArrayList<String>();
		StringTokenizer st = new StringTokenizer(valores, ",");
		while (st.hasMoreTokens()) {
			listaString.add(st.nextToken());
		}
		String[] array = listaString.toArray(new String[listaString.size()]);
		Arrays.sort(array);
		params[2] = array;
		super.setParams(params);
	}

	public ValorCampoFechaNacimientoFechaNovedad() {
		sdf = new SimpleDateFormat(DATE_FORMAT);
		sdf.setLenient(false);
	}

	public boolean performValidation(String field, String[] registro,
			String nombreArchivo) {

		String codigoNovedad = registro[new Integer((String) getParams()[0])
				.intValue()];

		if (codigoNovedad.equals((String) getParams()[1])) {
			String FechaNacimiento = registro[new Integer(
					(String) getParams()[3]).intValue()];
			if (!ValidarFecha.esFecha(FechaNacimiento))
				return false;
			Date dateNacimiento = null;

			try {
				dateNacimiento = sdf.parse(FechaNacimiento);
			} catch (Exception e) {
				return false;
			}

			if (field.length() > 0)
				if (Arrays.binarySearch((String[]) getParams()[2], field) < 0) {
					return true;
				}
			String FechaNovedad = registro[new Integer((String) getParams()[4])
					.intValue()];
			if (!ValidarFecha.esFecha(FechaNovedad))
				return false;
			Date dateFechaNovedad = null;
			try {
				dateFechaNovedad = sdf.parse(FechaNovedad);
			} catch (Exception e) {
				return false;
			}

			double annos = Math.floor(ObtenerDiasEntreFechas.calcular(
					dateNacimiento, dateFechaNovedad) / 365);

			if (annos > 18 && annos < 26 && field.equals("E")) {
				return false;
			} else if (annos > 18 && field.equals("D")) {
				return false;
			} else if (annos < 18) {
				if (field.length() > 0) {
					return true;
				}
				return false;
			}
			return true;
		}
		return false;
	}
}